/*
    Task: ex1-inventory-value.c
    Author: James Mulligan
    Date: 31/10/2024
    Description: Using the same input system as in the last task. Calculate the total value of all products,
        taking discounts into account.

    Solution: 
        - Same parse function as the last task
        - Make a function to calculate value of a product, taking the discount into account
        - Make a function to loop through array generating value of each product
        - Total these up and output.
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// typedefs
typedef struct Product Product;


// declare structs
struct Product
{
    char name[20];
    unsigned stock;
    float price;
    int discount;
};

/*
    The struct outlines the following:
    - name (product name) a string with max 20 chars
    - stock positive int representing no. of items available
    - price (float)
    - discount a binary (im using integer) value (1 = discount available, 0 = no discount)
*/

// function prototypes
void parseInput(int length, char*argv[], Product *products);
float calculateDiscount(Product *product);
float calculateTotalValue(int items, Product *products);

// main function
int main(int argc, char*argv[])
{
    int length = argc - 1;
    // this will give us the number of items we will have
    int items = length / 4;

    // initialise array of products
    Product products[100];
    // run functions
    parseInput(length, argv, products);
    float totalValue = calculateTotalValue(items, products);
    // output the result
    printf("%.2f\n", totalValue);

    // exit with code 0 if all okay
    return 0;
}

// actual function implementations
// using the same parse input function from the last task
void parseInput(int length, char*argv[], Product *products)
{
    // two variables here, i to keep track of where we are in the input args,
    // pos to keep track of where we are in our products array
    // add 4 onto i each time to move onto the next product in input
    for (int i = 0, pos = 0; i < length; i+=4, pos++)
    {
        // will use pointers here to manipulate values in the struct
        Product *newProduct;
        // assign our new product a location in the products array
        newProduct = &products[pos];
        // adding information, changing data type as needed.
        strcpy(newProduct->name, argv[i + 1]);
        newProduct->stock = atoi(argv[i + 2]);
        newProduct->price = atof(argv[i + 3]);
        newProduct->discount = atoi(argv[i + 4]);
    }
}

// this function will calculate value of product, taking into account discount if needed.
float calculateValue(Product *product)
{
    // if there is no discount
    if (product->discount == 0)
    {
        // return total value (no discount applied)
        return product->price * product->stock;
    }
    
    // else, return the value but taking the discount into account
    return product->price * product->stock * 0.9;
}        printf("%f\n", currVal);


// iterate through all products, and calculate value of each, total them up
float calculateTotalValue(int items, Product *products)
{
    // intialise our total
    float totalValue = 0;
    // loop through items
    for (int i = 0; i < items; i++)        printf("%f\n", currVal);

    {
        // get current products address
        Product *currentProduct = &products[i];

        float currVal = calculateValue(currentProduct);
        // add on to total
        totalValue += currVal;
    }

    // return total at the end.
    return totalValue;
}