/*
    Task: ex1-max-diff.c
    Author: James Mulligan
    Date: 31/10/2024
    Description: A number of integer inputs are given, this program must find the
        maximum difference between each of the inputs.

    Solution: 
        - I will use the fact that the biggest difference is the biggest number in the array - the smallest number
        - Firstly, make a function to parse the input from the command line into a numbers array
        - Then make 2 functions, to get the smallest and largest number in the array
        - Finally, subtract these and we have the answer!
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>

// function prototypes
void parseInput(int length, char*argv[], int *numbers);
int getSmallest(int length, int *numbers);
int getLargest(int length, int *numbers);

// main function
int main(int argc, char*argv[])
{
    // get amount of numbers given in the command line
    int length = argc - 1;
    // create an array with maximum size given
    int numbers[100];

    parseInput(length, argv, numbers);

    // get smallest & largest values in array
    int smallest = getSmallest(length, numbers);
    int largest = getLargest(length, numbers);

    // finally, calculate our difference
    int maxDiff = largest - smallest;

    // output it with a new line character
    printf("%d\n", maxDiff);

    return 0;
}


// actual function implementations
// using pass-by-reference here by passing the pointer of our numbers array to function
void parseInput(int length, char*argv[], int *numbers)
{
    for (int i = 0; i < length; i ++)
    {
        // +1 to skip the file name in args
        numbers[i] = atoi(argv[i + 1]);
    }
}

// simple function to find smallest integer in array
int getSmallest(int length, int *numbers)
{
    // always set the default return val to be the first item in the list
    int smallest = numbers[0];
    for (int // simple function to find smallest integer in array
i = 1; i < length; i ++)
    {
        if (numbers[i] < smallest)
        {
            smallest = numbers[i];
        }
    }

    // return the result at the end
    return smallest;
}

// simple function to find largest integer in array
int getLargest(int length, int *numbers)
{
    int largest = numbers[0];
    for (int i = 1; i < length; i ++)
    {
        // if current num is greater than what we have stored, then we have a new biggest number
        if (numbers[i] > largest)
        {
            // replace it
            largest = numbers[i];
        }
    }

    // return our result at the end
    return largest;
}