/*
    Lab 10, Task 2
    Task: lab10-float-doubly-linked-list.c
    You are required to implement a doubly linked list to store all floating numbers. 
    You are encouraged to use dynamic memory allocation in the program.
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>

// typedefs
typedef struct Node Node;

// structures
struct Node {
    float value;
    Node *next;
    Node *prev;
};

// function prototypes
Node* generateList(char*argv[], int length);
void printLinkedList(Node *firstNode);

// main function
int main(int argc, char*argv[])
{
    int length = atoi(argv[1]);
    
    Node* pLastNode = NULL;
    pLastNode = generateList(argv, length);
    printLinkedList(pLastNode);

    return 0;
}


// actual function implementation
Node* generateList(char*argv[], int length)
{
    // generates a linked list from the command line arguments
    // returns a pointer to the last node
    Node *firstNode, *currentNode;

    // set the first node
    firstNode = (Node*)calloc(1, sizeof(Node));
    // set the current node to be the first node
    currentNode = firstNode;
    currentNode->value = atoi(argv[2]);
    // set previous of the first node to be null
    currentNode->prev = NULL;

    // iterate through the remaining 
    for (int i = 1; i < length; i++)
    {
        // grab value from command line args
        int value = atoi(argv[i + 2]);

        // allocate some memory for the new node to add
        currentNode->next = (Node*)calloc(1, sizeof(Node));
        // move the current node to the next one in the list
        currentNode->next->prev = currentNode;
        currentNode = currentNode->next;

        // edit the value
        currentNode->value = value;
    }
    
    // set the last node next to NULL
    currentNode->next = NULL;
    return currentNode;
}

void printLinkedList(Node *lastNode)
{
    // set node initially to null
    Node* node = NULL;
    // iterate through every node.next until it hits null (the end)
    for (node = lastNode; node != NULL; node = node->prev)
    {
        // print the value
        printf("%.2f\n", node->value);
    }
}