/*
    Lab 10, Task 4
    Task: lab10-inside-the-queue.c
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>

// typedefs
typedef struct Node Node;

// structures
struct Node {
    int value;
    Node *next;
};

// function prototypes
void printLinkedList(Node *firstNode);
void push(Node *firstNode, int newValue);
void findAndInsert(Node *firstNode, int target, int newVal);

// main function
int main(int argc, char*argv[])
{
    // first generate linked list using the given set of numbers

    int size = 10;
    int nums[] = {8, 7, 3, 4, 5, 6, 9, 2, 14, 12};
    
    // set the first node manually as its easier in this case
    Node* pFirstNode = (Node*)calloc(1, sizeof(Node));
    pFirstNode->value = nums[0];

    // start looping from the second value
    for (int i = 1; i < size; i++)
    {
        push(pFirstNode, nums[i]);
    }

    // get our values from the command line
    int target = atoi(argv[1]);
    int toInsert = atoi(argv[2]);

    findAndInsert(pFirstNode, target, toInsert);
    
    printLinkedList(pFirstNode);
    return 0;
}


// actual function implementation

void printLinkedList(Node *firstNode)
{
    // set node initially to null
    Node* node = NULL;
    // iterate through every node.next until it hits null (the end)
    for (node = firstNode; node != NULL; node = node->next)
    {
        // print the value
        printf("%d\n", node->value);
    }
}

void push(Node *firstNode, int newValue)
{
    Node* curr = firstNode;

    Node* newNode = (Node*)calloc(1, sizeof(Node));
    newNode->value = newValue;

    // keep going to the next node until it hits NULL (the end)
    while (curr->next != NULL)
    {
        curr = curr->next;
    }

    curr->next = newNode;
}

void findAndInsert(Node *firstNode, int target, int newVal)
{
    Node *curr = firstNode;
    // find the position of the target
    while (curr->next != NULL && curr ->value != target)
    {
        curr = curr->next;
    }

    Node* newNode = (Node*)calloc(1, sizeof(Node));
    // update value of new node
    newNode->value = newVal;
    // set the new node next to original next node
    newNode->next = curr->next;
    // finally set current to the new node
    curr->next = newNode;
}