/*
    Lab 10, Task 1
    Task: lab10-integer-singly-linked-list.c
    You are required to implement a singly linked list to store all integers. 
    You are encouraged to use dynamic memory allocation in the program.
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>

// typedefs
typedef struct Node Node;

// structures
struct Node {
    int value;
    Node *next;
};

// function prototypes
Node* generateList(char*argv[], int length);
void printLinkedList(Node *firstNode);

// main function
int main(int argc, char*argv[])
{
    int length = atoi(argv[1]);
    
    Node* pFirstNode = NULL;
    pFirstNode = generateList(argv, length);
    printLinkedList(pFirstNode);

    return 0;
}


// actual function implementation
Node* generateList(char*argv[], int length)
{
    // generates a linked list from the command line arguments
    // returns a pointer to the first node
    Node *firstNode, *currentNode;

    // set the first node
    firstNode = (Node*)calloc(1, sizeof(Node));
    // set the current node to be the first node
    currentNode = firstNode;
    currentNode->value = atoi(argv[2]);

    // iterate through the remaining 
    for (int i = 1; i < length; i++)
    {
        // grab value from command line args
        int value = atoi(argv[i + 2]);

        // allocate some memory for the new node to add
        currentNode->next = (Node*)calloc(1, sizeof(Node));
        // move the current node to the next one in the list
        currentNode = currentNode->next;

        // edit the value
        currentNode->value = value;
    }
    
    // set the last node next to NULL
    currentNode->next = NULL;
    return firstNode;
}

void printLinkedList(Node *firstNode)
{
    // set node initially to null
    Node* node = NULL;
    // iterate through every node.next until it hits null (the end)
    for (node = firstNode; node != NULL; node = node->next)
    {
        // print the value
        printf("%d\n", node->value);
    }
}
