/*
    Labsheet: 11, Task: 3
    Date: 21/11/24
    Task: lab11-bin-2-dec.c
    Description: Convert Binary to Decimal
*/

// include neccessary libraries
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define FILE_NAME "paragraph.txt"
#define MAX 200

// function prototypes
void parseNumbers(char*argv[], int *binNums, int length);
int binToDec(int *binNums, int length);
int power(int x, int y);

// main function
int main(int argc, char*argv[])
{
    int length = argc - 1;
    if (length > 8)
    {
        printf("Too many binary digits entered.\n");
        exit(0);
    }
    
    int binNums[8];

    parseNumbers(argv, binNums, length);
    int result = binToDec(binNums, length);
    printf("%d\n", result);

    return 0;
}

// actual function implementations
void parseNumbers(char*argv[], int *binNums, int length)
{
    for (int i = 0; i < length; i++)
    {
        // use strings here to ensure no pesky "a" values get through
        char* curr = argv[i + 1];
        if (strcmp(curr, "0") != 0 && strcmp(curr, "1") != 0)
        {
            printf("Only digits 1 and 0 are permitted.\n");
            exit(0);
        }
        // then convert to integer
        binNums[i] = atoi(curr);
    }
}

int binToDec(int *binNums, int length)
{
    int res = 0;
    // iterate through all binary numbers
    for (int i = 0; i < length; i++)
    {
        // add the calulcated power to the result
        res += binNums[i] * power(2, length - i - 1);
    }
    // return resulting decimal number at the end
    return res;
}

// power function
int power(int x, int y)
{
    // edge case for y = 0
    if (y == 0) { return 1; }

    int res = 1;
    for (int i = 0; i < y; i++)
    {
        // multiply by x for every exponenet 
        res *= x;
    }
    return res;
}