/*
    Lab 4, Task 1
    Name: lab4-find-most-character.c
    Description: The program find the character which has the most number of appearance in the string and print the character out
    Input: ./lab4-find-most-character "abcxyzbcc"
    Output: c
*/

#include <stdio.h>
#include <string.h>

// this includes alnum() function
#include <ctype.h>

// function prototypes
void findMostFreq(char *string, int *mostOccuring, char *mostOccuredChar);

int main(int argc, char*argv[]) {
    char *string = argv[1];
    int mostOccuring = -1;
    // this will be the result
    char mostOccuredChar;

    // using & here to pass the variable pointers into the function
    findMostFreq(string, &mostOccuring, &mostOccuredChar);

    printf("%c\n", mostOccuredChar);

    return 0;
}

// use a void function here as pointers are used to edit variables
// use * here to say we are expecting pointers to be passed into function
void findMostFreq(char *string, int *mostOccuring, char *mostOccuredChar) {
    int length = strlen(string);
    // define a list to hold all counts of characters
    // max num here is 128 as that is the amount of ascii characters that exist
    // set all to 0 at the start
    char charCounts[128] = {0};

    for (int i = 0; i < length; i++) {
        // check if character is 0-9 a-z
        if (isalnum(string[i])) {
            // simply increment every char count when found
            charCounts[string[i]] ++;
        }
    }

    for (int i = 0; i < sizeof(charCounts); i++) {
        if (charCounts[i] > *mostOccuring) {
            // use * here to convert pointers back to value
            *mostOccuring = charCounts[i];
            // make sure to convert i (decimal number which is ascii value here) back to character.
            *mostOccuredChar = (char)i;
        }
    }
}