/*
    Lab 5, Task 4
    Name: lab5-get-countries.c
    Input: ./lab5-get-countries Ireland Dublin 4.99 84421 France Paris 67.39 632734 Germany Berlin 83.24 357386
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// create the country struct
struct Country {
    char Name[50];
    char Capital[50];
    float Population;
    int Size;
};

// shortcut the country struct so it can be called easier
typedef struct Country Country;

// function prototypes
void parseInput(Country *countries, char*args[], int countryCount);
void generateTable(Country *countries, int countryCount);

int main(int argc, char*argv[])
{
    // declare an array of Country structs to hold all our countries
    Country countries[50];
    int countryCount = argc / 4;

    // call our functions to do their work
    parseInput(countries, argv, countryCount);
    generateTable(countries, countryCount);

    // exit with code 0 if all okay
    return 0;
}

// actual function implementations
/* this function takes the command line args 
   and parses them into the struct and then adds them to the array */

void parseInput(Country *countries, char*args[], int countryCount)
{
    // multiply by 4 here to get the total amount of arguments we need to parse
    for (int i = 0; i < (countryCount * 4); i = i + 4)
    {
        Country newCountry;
        // always increment by atleast one here so the first argument isn't considered
        strcpy(newCountry.Name, args[i + 1]);
        strcpy(newCountry.Capital, args[i + 2]);
        newCountry.Population = atof(args[i + 3]);
        newCountry.Size = atoi(args[i + 4]);

        // get the division here so our placement in the array is correct
        countries[i / 4] = newCountry;
    }
}
/* This function takes the country array and prints it to the command line in the desired format */
void generateTable(Country *countries, int countryCount)
{
    // print heading line
    printf("Country\t\t\tCapital\t\t\tSize\t\t\tPopulation\n");

    // print each country
    for (int i = 0; i < countryCount; i++)
    {
        printf("%s\t\t\t%s\t\t\t%d\t\t\t%.2f\n", countries[i].Name, countries[i].Capital, countries[i].Size, countries[i].Population);
    }
}