/*
    Lab 5, Task 2
    Name: lab5-sort-numbers.c
    Input: ./lab5-sort-numbers 5 42 23 56 15 8 asc
    Output: Sorted numbers: 8 15 23 42 56
*/

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

// function prototypes
void sortAscending(int *arr, int length);
void sortDescending(int *arr, int length);

int main(int argc, char*argv[])
{
    int length = atoi(argv[1]);
    int numbers[length];
    char *mode = argv[length + 2];

    // get all numbers from the arguments and add to array
    for (int i = 0; i < length; i++)
    {
        numbers[i] = atoi(argv[i + 2]);
    }

    // create a pointer which will point to the correct sorting function
    void (*sortFunc)(int*, int) = NULL;
    if (strcmp(mode, "asc") == 0)
    {
        sortFunc = sortAscending;
    } else if (strcmp(mode, "desc") == 0)
    {
        sortFunc = sortDescending;
    }
    sortFunc(numbers, length);

    // print out the sorted array in the correct format
    printf("Sorted numbers:");
    for (int i = 0; i < length; i++)
    {
        printf(" %d", numbers[i]);
    }

    printf("\n");

    return 0;
}

// actual function implementations

// the following two functions are bubble sort algorithms in two different orders.
void sortAscending(int *arr, int length) {
    for (int i = 0; i < length - 1; i++)
    {
        // -i here to reduce the inner loop size on every iteration
        for (int j = 0; j < length - 1 - i; j++)
        {
            if (arr[j] > arr[j + 1])
            {
                // carry out a swap
                int tmp = arr[j];
                arr[j] = arr[j + 1];
                arr[j + 1] = tmp;
            }
        }
        
    } 
}


void sortDescending(int *arr, int length)
{
    for (int i = 0; i < length - 1; i++)
    {
        // -i here to reduce the inner loop size on every iteration
        for (int j = 0; j < length - 1 - i; j++)
        {
            if (arr[j] < arr[j + 1])
            {
                // carry out a swap
                int tmp = arr[j];
                arr[j] = arr[j + 1];
                arr[j + 1] = tmp;
            }
        }
        
    } 
}