/*
    Labsheet 6, Task 3
    Name: lab6-countries-cities.c
    Example Input: ./lab6-countries-cities Ireland Dublin 117.8 Cork 187 Galway 54.2 France Paris 105.4 Marseille 240.6 Lyon 47.87 Spain Madrid 604.3 Barcelona 101.4 Sevilla 140
*/

// import necessary libraries
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

// structures
typedef struct Country Country;
typedef struct City City;

struct City {
    char Name[50];
    float Size;
};

struct Country {
    char Name[50];
    City Cities[3];
};


// function prototypes
void parseInput(Country *countries, char*args[], int countryCount);
void generateOutput(Country *countries, int countryCount);
City* getBiggestCity(Country *country);

// main function
int main(int argc, char*argv[])
{

    int countryCount = (argc - 1) / 7;

    Country countries[countryCount];

    parseInput(countries, argv, countryCount);

    generateOutput(countries, countryCount);

    return 0;
}

// actual function implementations
void parseInput(Country *countries, char*args[], int countryCount)
{

    for (int i = 1; i < countryCount * 7; i += 7)
    {
        Country newCountry;
        strcpy(newCountry.Name, args[i]);

        // this gets each city in the country
        // we know here will be 3 cities in each country (6 things including size)
        // + 2 to j every time to skip over the size
        // pos is a variable for positioning the city in the cities struct array
        for (int j = 0, pos = 0; j < 6; j+=2, pos++)
        {
            // extract city name and size from the input array
            strcpy(newCountry.Cities[pos].Name, args[i + j + 1]);
            newCountry.Cities[pos].Size = atof(args[i + j + 2]);
        }
        // add the new country to the correct position of the countries array
        countries[(i - 1) / 7] = newCountry;
    }
}

// function to output the data
void generateOutput(Country *countries, int countryCount)
{
    for (int i = 0; i < countryCount; i++)
    {
        City *biggest = getBiggestCity(&countries[i]);
        printf("%s: %s\n", countries[i].Name, biggest->Name);
    }
    
}

// function that finds
City *getBiggestCity(Country *country) {
    City *biggestCity = &country->Cities[0];

    // it is safe to hardcode 3 here as we know there is a max of three cities
    for (int i = 1; i < 3; i++)
    {
        // check here 
        if (country->Cities[i].Size > biggestCity->Size) {
            biggestCity = &country->Cities[i];
        }
    }

    return biggestCity;
}