/*
    Labsheet 6, Task 1
    Name: lab6-find-country.c
    Example Input: ./lab6-find-country Ireland Dublin 4.99 84421 Germany Berlin 83.24 357386 France Paris 67.39 632734
*/

// include necessary libraries
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

// define structs & typedefs
typedef struct Country Country;
struct Country {
    char Name[50];
    char Capital[50];
    int Size;
    float Population;
};

// function prototypes
void parseInput(Country *countries, char*args[], int countryCount);
void outputTable(Country *countries, int countryCount);

// main
int main(int argc, char*argv[])
{
    // divide the input count by 4 to get the amount of countries we have.
    int countryCount = (argc - 1) / 4;
    Country countries[50];
    
    parseInput(countries, argv, countryCount);

    outputTable(countries, countryCount);
    return 0;
}


// actual function implementations
void parseInput(Country *countries, char*args[], int countryCount)
{
    for (int i = 1, j = 0; i < countryCount * 4; i += 4, j++)
    {
        Country *newCountry;
        // this adds the address of the new country struct
        // &countries[j] is the address
        newCountry = &countries[j];

        strcpy(newCountry->Name, args[i]);
        strcpy(newCountry->Capital, args[i + 1]);
        newCountry->Population = atof(args[i + 2]);
        newCountry->Size = atoi(args[i + 3]);
    }
}

// output the countries that are less than 100000 km
void outputTable(Country *countries, int countryCount)
{
    // initialise pointer for country
    Country *curr = NULL;
    printf("Country\t\t\tCapital\t\t\tSize\t\t\tPopulation\n");

    for (int i = 0; i < countryCount; i++)
    {   
        // * references the data in countries
        // & references the address of countries
        curr = &countries[i];
        if (curr->Size < 100000)
        {
            // print the country in given format if size is less then 100000
            printf("%s\t\t\t%s\t\t\t%d\t\t\t%.2f\n", curr->Name, curr->Capital, curr->Size, curr->Population);
        }
    }
}