/*
    Labsheet 6, Task 1
    Name: lab6-sort-countries.c
    Example Input: ./lab6-sort-countries.out Ireland Dublin 4.99 84421 Germany Berlin 83.24 357386 France Paris 67.39 632734
*/

// include necessary libraries
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

// define structs & typedefs
typedef struct Country Country;
struct Country {
    char Name[50];
    char Capital[50];
    int Size;
    float Population;
};

// function prototypes
void parseInput(Country *countries, char*args[], int countryCount);
void sortByPop(Country *countries, int countryCount);
void outputTable(Country *countries, int countryCount);

// main
int main(int argc, char*argv[])
{
    // divide the input count by 4 to get the amount of countries we have.
    int countryCount = (argc - 1) / 4;
    Country countries[50];
    
    parseInput(countries, argv, countryCount);

    sortByPop(countries, countryCount * 4);

    outputTable(countries, countryCount);
    return 0;
}


// actual function implementations
void parseInput(Country *countries, char*args[], int countryCount)
{
    for (int i = 1, j = 0; i < countryCount * 4; i += 4, j++)
    {
        Country *newCountry;
        // this adds the address of the new country struct
        // &countries[j] is the address
        newCountry = &countries[j];

        // set all details in the new struct
        strcpy(newCountry->Name, args[i]);
        strcpy(newCountry->Capital, args[i + 1]);
        newCountry->Population = atof(args[i + 2]);
        newCountry->Size = atoi(args[i + 3]);
    }
}

// bubble sort algorithm to sort the array
void sortByPop(Country *countries, int countryCount)
{
    // initialise the variables we will use
    Country *pCurr = NULL;
    Country *pNext = NULL;
    Country temp;

    for (int i = 0; i < countryCount - 1; i++)
    {
        for (int j = 0; j < countryCount - i - 1; j++)
        {
            // get the pointers for the current and next element in the array
            pCurr = &countries[j];
            pNext = &countries[j + 1];

            // check if the current country's population is less then the next country's one
            if (pCurr->Population < pNext->Population)
            {
                // preform a swap
                temp = *pCurr;
                *pCurr = *pNext;
                *pNext = temp;
            }
        }
        
    }
}

// output the countries that are less than 100000 km
void outputTable(Country *countries, int countryCount)
{
    // initialise pointer for country
    Country *curr = NULL;
    // print the header
    printf("Country\t\t\tCapital\t\t\tSize\t\t\tPopulation\n");

    for (int i = 0; i < countryCount; i++)
    {   
        // * references the data in countries
        // & references the address of countries
        curr = &countries[i];
        printf("%s\t\t\t%s\t\t\t%d\t\t\t%.2f\n", curr->Name, curr->Capital, curr->Size, curr->Population);
    }
}