/*
    Labsheet 9, Task 1
    Task: lab9-dot-product-two-vector.c
    Description: Find the dot product of two vectors
*/

// include necessary libraries
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

// function prototype
// this function will 
int dotProduct(int *pMatrix1, int *pMatrix2, int size);

// main function
int main(int argc, char*argv[])
{
    int size = atoi(argv[1]);
    int length = argc - 2;

    // allocate dynamically the size of our two matrixes
    int *pMatrix1 = (int*)malloc(size*sizeof(int));
    int *pMatrix2 = (int*)malloc(size*sizeof(int));

    // ensure the memory was actually allocated
    if (!pMatrix1 || !pMatrix2) {
        printf("Failed to allocated memory!\n");
        return 0;
    }

    for (int i = 0, j = (argc / 2); i < length / 2; i++, j++)
    {
        // go to the correct pointer and edit the value
        *(pMatrix1 + i) = atoi(argv[i + 2]);
        *(pMatrix2 + i) = atoi(argv[j + 1]);
    }
    
    int dotProd = dotProduct(pMatrix1, pMatrix2, size);
    printf("%d\n", dotProd);

    // free the memory allocated when done
    free(pMatrix1);
    free(pMatrix2);
    pMatrix1 = NULL;
    pMatrix2 = NULL;

    return 0;
}

// actual function implementations
int dotProduct(int *pMatrix1, int *pMatrix2, int size)
{
    int total = 0;
    for (int i = 0; i < size; i++)
    {
        // add the multiplication of two vectors to the total
        total += *(pMatrix1 + i) * *(pMatrix2 + i);
    }

    // return total at the end
    return total;
}
