/*
    Task 3, Labsheet 9
    Task: lab9-largest-twice.c
    Description: find the largest element which is at least twice as much as at least one number in the array, print the result
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>

// function prototypes
void parseInput(int *numbers, int length, char*argv[]);
int getLargestTwice(int *numbers, int length);
int findMax(int *numbers, int length);
int findMin(int *numbers, int length);

// main function
int main(int argc, char*argv[])
{
    int length = argc - 1;
    int *pNumbers = (int*)malloc(length * sizeof(int));

    parseInput(pNumbers, length, argv);
    int result = getLargestTwice(pNumbers, length);

    printf("%d\n", result);

    free(pNumbers);
    pNumbers = NULL;
    
    return 0;
}

// actual function implementations
void parseInput(int *numbers, int length, char*argv[])
{
    for (int i = 0; i < length; i++)
    {
        *(numbers + i) = atoi(argv[i + 1]);
    }   
}

int getLargestTwice(int *numbers, int length)
{
    int result = 0;

    // find the min and max, this checks if longest is twice the min (giving the result)

    int max = findMax(numbers, length);
    int min = findMin(numbers, length);

    if (max >= min * 2)
    {
        result = max;
    }

    return result;
}

// simple max function
int findMax(int *numbers, int length)
{
    int max = *numbers;

    for (int i = 0; i < length; i++)
    {
        if (*(numbers + i) > max)
        {
            max = *(numbers + i);
        }
    }

    return max;
}

// simple find min function
int findMin(int *numbers, int length)
{
    int min = *numbers;

    for (int i = 0; i < length; i++)
    {
        if (*(numbers + i) < min)
        {
            min = *(numbers + i);
        }
    }

    return min;
}