/*
    Labsheet 9, Task 4
    Task: lab9-longest-sentence.c
    Description: The program finds and prints the longest string(s) line by line.
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// declare function prototypes
void generateStringArray(char **words, int length, char*argv[]);
char* getLargestString(char **words, int length);
void printWordsOfLength(char **words, int length, char *target);

// main function
int main(int argc, char*argv[])
{
    int length = argc - 1;

    // allocate memory to store pointers to pointers of strings
    char **words = (char **)malloc(length * sizeof(char *));

    // call our generate string function
    generateStringArray(words, length, argv);

    // find the largest string
    char* largestStr = getLargestString(words, length);
    // output the strings in the array that have this length
    printWordsOfLength(words, length, largestStr);
    return 0;
}


// actual function implementations
void generateStringArray(char **words, int length, char*argv[])
{
    for (int i = 0; i < length; i++)
    {
        // allocate some memory for our new string
        *(words + i) = (char *)malloc(strlen(argv[i + 1]));
        strcpy(*(words + i), argv[i + 1]);
    }
}

char* getLargestString(char **words, int length)
{
    char* longest = words[0];
    for (int i = 0; i < length; i++)
    {
        // loop through all words and get the one with the longest length
        if (strlen(words[i]) > strlen(longest))
        {
            longest = words[i];
        }
    }

    return longest;
}

void printWordsOfLength(char **words, int length, char *target)
{
    // find all words with length of target and print them
    int targetLength = strlen(target);

    for (int i = 0; i < length; i++)
    {
        if (strlen(words[i]) == targetLength)
        {
            printf("%s\n", words[i]);
        }
    }   
}