/*
    Labsheet 9, Task 5
    Task: lab9-student.c
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// typedefs
typedef struct Student Student;

// structs
struct Student
{
    char name[20];
    char programme[20];
    float grade;
};


// declare function prototypes
int parseInput(char*argv[], int length, Student* pStudent);
float getAverageGrade(Student* pStudent, int length);
void printStudents(Student* pStudent, int length, float avg);

// main function
int main(int argc, char*argv[])
{
    Student* pStudent;
    // allocate memory for students initially (2)
    pStudent = (Student*)calloc(2, sizeof(Student));
    if(!pStudent) /* Check if the allocation is successful */
    {
        printf("Not enough memory. Exiting...\n");
        free(pStudent);
        pStudent = NULL;
        exit(0);
    }
    
    int length = parseInput(argv, argc, pStudent);
    float avg = getAverageGrade(pStudent, length);
    printStudents(pStudent, length, avg);
    printf("Average grade: %.2f\n", avg);

    // clean up when we are done
    free(pStudent);
    pStudent = NULL;

    return 0;
}


// actual function implementations
int parseInput(char*argv[], int length, Student* pStudent)
{
    // 2 at the start
    int capacity = 2;

    int count = 0;
    for (int i = 0; i < length - 1; i+=3)
    {
        if (count == capacity)
        {
            // more space is needed
            Student *pTemp;
            capacity += 10;
            pTemp = (Student*)realloc(pStudent, capacity*sizeof(Student));
            if(!pTemp)  /* Check if the re-allocation is successful */
            {
                printf("Unfortunately memory reallocation failed. Exiting...\n");
                free(pStudent);
                pStudent = NULL;
                exit(0);
            }
            // allocate after to avoid overwriting if there is a fail
            pStudent = pTemp;
        }

        strcpy((pStudent+count)->name, argv[i + 1]);
        strcpy((pStudent+count)->programme, argv[i + 2]);
        (pStudent+count)->grade = atof(argv[i + 3]);
        count ++;
    }

    // return the amount of students parsed
    return count;
}

float getAverageGrade(Student* pStudent, int length)
{
    float total = 0;
    for (int i = 0; i < length; i++)
    {
        total += (pStudent + i)->grade;
    }
    return total / length;
}

void printStudents(Student* pStudent, int length, float avg)
{
    for (int i = 0; i < length; i++)
    {
        // only print students whos grade is above avg
        // and that they do CSCE
        if (strcmp(pStudent[i].programme, "CSCE") == 0 && pStudent[i].grade >= avg)
        {
            printf("%s, %.2f\n", pStudent[i].name, pStudent[i].grade);
        }
    }
    
}