/*
    Labsheet 9, Task 2
    Task: lab9-second-largest.c
    Description: Find the second largest float in input
*/

// include necessary libraries
#include <stdio.h>
#include <stdlib.h>

// function prototype
void parseInput(float *pNumbers, int length, char * argv[]);
void sortFloatArray(float *pNumbers, int length);
float getSecondLgst(float *pNumbers, int length);

// main function
int main(int argc, char*argv[])
{
    int length = argc - 1;

    // allocate dynamically the size of array
    float *pNumbers = (float*)malloc(length*sizeof(float));

    // ensure the memory was actually allocated
    if (!pNumbers) {
        printf("Failed to allocated memory!\n");
        return 0;
    }

    parseInput(pNumbers, length, argv);

    sortFloatArray(pNumbers, length);
    // array is now sorted in descending order
    
    // get the second largest, ignoring duplicates
    float secondLgst = getSecondLgst(pNumbers, length);
    printf("%.1f\n", secondLgst);

    // free the memory allocated when done
    free(pNumbers);
    pNumbers = NULL;

    return 0;
}

// actual function implementations
void parseInput(float *pNumbers, int length, char * argv[])
{
    // loop through all inputs and add to pointer array
    for (int i = 0; i < length; i++)
    {
        *(pNumbers + i) = atof(argv[i + 1]);
    }
}

void sortFloatArray(float *pNumbers, int length)
{
    // bubble sort descending algorithm
    for (int i = 0; i < length; i++)
    {
        for (int j = 0; j < length - i; j++)
        {
            if (*(pNumbers + j) < *(pNumbers + j + 1))
            {
                // preform swap
                float tmp = *(pNumbers + j);
                *(pNumbers + j) = *(pNumbers + j + 1);
                *(pNumbers + j + 1) = tmp;
            }
        }
        
    }
    
}

float getSecondLgst(float *pNumbers, int length)
{
    float largest = *(pNumbers);
    for (int i = 1; i < length; i++)
    {
        if (*(pNumbers + i) == largest) {
            largest = *(pNumbers + i);
        } else {
            // result = *(pNumbers + i + 1);
            return *(pNumbers + i);
        }
    }

    return largest;
}