/*
    Task: ex1-largest-smallest.c
    Date: 31/10/2024
    Description:
        - Firstly parse input into an array
        - make 2 functions to get the largest or smallest number
        - use strcmp to check which one to use
        - output the result
*/

// include necessary libraries
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

// function prototypes
float getLargest(int length, float numbers[]);
float getSmallest(int length, float numbers[]);
void parseInput(int length, char*argv[], float *numbers);

// main function
int main(int argc, char*argv[])
{
    int length = argc - 2;
    float numbers[50];
    // define a new pointer which will point to the correct largest or smallest function
    float (*pFunction)(int, float*) = NULL;

    // get mode from input args
    char* mode = argv[1];

    // parse the input and add to numbers array
    parseInput(length, argv, numbers);

    // use strcmp to check if we need to find largest or smallest
    if (strcmp(mode, "largest") == 0)
    {
        // 
        pFunction = getLargest;
    } else {
        pFunction = getSmallest;
    }

    float result = pFunction(length, numbers);

    printf("%.2f\n", result);

    return 0;
}


// function implementations
void parseInput(int length, char*argv[], float *numbers)
{
    for (int i = 0; i < length; i++)
    {
        // use +2 here to skip over the largest/smallest text in input
        numbers[i] = atof(argv[i + 2]);
    }
    
}

// simple find largest function
float getLargest(int length, float numbers[])
{
    float currLargest = numbers[0];
    for (int i = 0; i < length; i++)
    {
        if (numbers[i] > currLargest)
        {
            currLargest = numbers[i];
        }
    }
    return currLargest;
}

float getSmallest(int length, float numbers[])
{
    float currSmallest = numbers[0];
    for (int i = 0; i < length; i++)
    {
        if (numbers[i] < currSmallest)
        {
            currSmallest = numbers[i];
        }
    }
    return currSmallest;
}